Smokeping_probes_TraceroutePing(3)

NAME
Smokeping::probes::TraceroutePing - use traceroute to obtain RTT for a router

SYNOPSIS
 *** Probes ***

 +TraceroutePing

 binary = /usr/bin/traceroute # mandatory
 binaryv6 = /usr/bin/traceroute6
 forks = 5
 offset = 50%
 step = 300
 timeout = 15

 # The following variables can be overridden in each target section
 /^influx_.+/ = influx_location = In the basement
 desthost = www.example.com # mandatory
 host = www-net-router.example.com # mandatory
 maxttl = 15
 minttl = 11
 pings = 5
 wait = 3

 # [...]

 *** Targets ***

 probe = TraceroutePing # if this should be the default probe

 # [...]

 + mytarget
 # probe = TraceroutePing # if the default probe is something else
 host = my.host
 /^influx_.+/ = influx_location = In the basement
 desthost = www.example.com # mandatory
 host = www-net-router.example.com # mandatory
 maxttl = 15
 minttl = 11
 pings = 5
 wait = 3

DESCRIPTION
Integrates standard traceroute as a probe into smokeping. The use case for this probe is gateways that do not respond to TCP/UDP/ICMP packets addressed to them, but do return ICMP TTL_EXCEEDED packets for traceroute packets to a host they route to. It is best used in situations where routing for the path is static or nearly so; attempting to use this on networks with changing routing will yield poor results. The best place to use this probe is on first- and last-mile links, which are more likely to have static routing and also more likely to have firewalls that ignore ICMP ECHO_REQUEST.

The mandatory probe variable binary must have an executable path for traceroute.

The optional probe variable binaryv6 sets an executable path for your IPv6 traceroute. If this is set to the same value as binary, TraceroutePing will use the -6 flag when running traceroute for IPv6 addresses. If this variable is not set, TraceroutePing will try to find an functioning IPv6 traceroute. It will first try appending "6" to the path in binary, then try including the "-6" flag in a test command. Note that Linux appears to have a wide variety of IPv6 traceroute implementations. My Ubuntu 14.04 machine has /usr/sbin/traceroute6 from iputils, but /usr/bin/traceroute (from Dmitry Butskoy) accepts the -6 flag and is actually a better implementation. You may need to let TraceroutePing autodetect this, or experiment to find the best traceroute.

The mandatory target variable desthost must name a destination host for the probe. The destination host itself is not of interest and no data is gathered on it, its only purpose is to route traffic past your actual target. Selection of a destination just past your target, with static or strongly preferred routing through your target, will get better data.

The mandatory target variable host must name the target host for the probe. This is the router that you want to collect RTT data for. This variable must either be the valid reverse-lookup name of the router, or its IP address. Using the IP address is preferable since it allows us to tell traceroute to avoid DNS lookups.

The target variables minttl and maxttl can be used to describe the range of expected hop counts to host. On longer paths or paths through unresponsive gateways or ending in unresponsive hosts, this reduces the amount of time this probe takes to execute. These default to 1 and 30.

The target variables wait sets the traceroute probe timeout in seconds. This defaults to 1, instead of the traditionally higher value used by LBL traceroute. Traceroute programs often enforce a lower bound on this value.

VARIABLES
Supported probe-specific variables:

binary
    The location of your traceroute binary.

    Example value: /usr/bin/traceroute

    This setting is mandatory.

binaryv6
    The location of your IPv6 traceroute binary.

    Example value: /usr/bin/traceroute6

forks
    Run this many concurrent processes at maximum

    Example value: 5

    Default value: 5

offset
    If you run many probes concurrently you may want to prevent them from hitting your network all at the same time. Using the probe-specific offset parameter you can change the point in time when each probe will be run. Offset is specified in % of total interval, or alternatively as 'random', and the offset from the 'General' section is used if nothing is specified here. Note that this does NOT influence the rrds itself, it is just a matter of when data acquisition is initiated. (This variable is only applicable if the variable 'concurrentprobes' is set in the 'General' section.)

    Example value: 50%

step
    Duration of the base interval that this probe should use, if different from the one specified in the 'Database' section. Note that the step in the RRD files is fixed when they are originally generated, and if you change the step parameter afterwards, you'll have to delete the old RRD files or somehow convert them. (This variable is only applicable if the variable 'concurrentprobes' is set in the 'General' section.)

    Example value: 300

timeout
    How long a single 'ping' takes at maximum

    Example value: 15

    Default value: 5

Supported target-specific variables:

/^influx_.+/
    This is a tag that will be sent to influxdb and has no impact on the probe measurement. The tag name will be sent without the "influx_" prefix, which will be replaced with "tag_" instead. Tags can be used for filtering.

    Example value: influx_location = In the basement

desthost
    Final destination host for traceroute packets. Does not have to be reachable unless it is also your host.

    Example value: www.example.com

    This setting is mandatory.

host
    Host of interest to monitor. Must be either the host's reverse-lookup name, or an IP address.

    Example value: www-net-router.example.com

    This setting is mandatory.

maxttl
    Maximum TTL. Set to the maximum expected number of hops to host.

    Example value: 15

minttl
    Minimum TTL. Set to the minimum expected number of hops to host.

    Example value: 11

pings
    How many pings should be sent to each target, if different from the global value specified in the Database section. Note that the number of pings in the RRD files is fixed when they are originally generated, and if you change this parameter afterwards, you'll have to delete the old RRD files or somehow convert them.

    Example value: 5

wait
    Waittime. The timeout value for traceroute's probes, in seconds.

    Example value: 3

AUTHORS
John Hood <cgull@glup.org>,

SEE ALSO
smokeping_extend